Maxim maxim;
AudioFilePlayer[] drum=new AudioFilePlayer[6];
Synth[] waveform=new Synth[8]; //array of synths for polyphony
int[] voiceAge=new int[8];
float[] wavetable = new float[514]; 
int oct=64;
PFont f;
String[] message;
Word[] words;
int wc=0;//word counter
int shelfL; //length of shelf
int shelfX, shelfY; //shelf starting position
int phraseS, phraseP, phraseV, currP;
float hotSpot;//the x position to trigger drum sounds
int textsize=20;
int playhead=0;
int currV=0;
int age;
float vpx, vpy;
float fallSpeed=0.6;
float spinSpeed=PI/40;
int shrink=3;
int messnum=0;
int maxtsize=300;
int bgnow=bginit=0;
int hsnow=0;

/////////////// Setup
void setup()
{
  size(600, 400);
  vpx=width/2;
  vpy=height/2;
  //setup words
  f = createFont("Arial",300,true);
  textFont(f);
  shelfL=width-50-200;
  phraseS=0;
  shelfX=200;
  shelfY=100;
  phraseP=phraseV=500;
  hotSpot=width*2/3;
  
  // setup alternative texts to drive the synth
  message=new String[5];
  message[0]="The Truth is a Lemon Meringue; but the Truth is not a Banana Cream Pie.";
  //message[0]="The Truth3<? is a!> Lemon1 Meringue and 1I Love@ it said @Mr Gum 4444 in$ This Pigeon Pie of my££ Life";
  message[1]="B1@a 2a_2 Ebub 3^2r B1@aie 2hha_2 Ebbb 3ei^2r Ba 2a_2 Ebbrrib 3^2abcr B1ui@a 2a_2 Ebbb 3^2r";
  message[2]="It is a Truth Universally acknowledged, That a single Man in possession of a Good Fortune, must be in Want of a Wife. ";
  message[3]="The Quick Brown fox, jumps Over the Lazy Dog. ";
  message[4]="Jammy Grammy Lammy F'Huppa F'Huppa Berlin Stereo Eo Eo Lebb C'Yepp Nermonica Le Straypek De Grespin De Crespin De Spespin De Vespin De Whoop De Loop De Brunkle Merry Christmas Lenoir ";
  words=new Word[25]; //create array of words
  initWords(0);

  //setup sounds
  maxim = new Maxim(this);
  drum[0] = maxim.loadFile("1bd1.wav", 2048);
  drum[0].setLooping(false);
  drum[0].volume(0.9);
  drum[1] = maxim.loadFile("1snare.wav", 2048);
  drum[1].setLooping(false);
  drum[1].volume(0.35);
  drum[2] = maxim.loadFile("1hh1.wav", 2048);
  drum[2].setLooping(false);
  drum[2].volume(0.6);
  drum[3] = maxim.loadFile("1crashb.wav", 2048);
  drum[3].setLooping(false);
  drum[3].volume(0.75);
  drum[4] = maxim.loadFile("1clap.wav", 2048);
  drum[4].setLooping(false);
  drum[4].volume(0.5);
  drum[5] = maxim.loadFile("1pop.wav", 2048);
  drum[5].setLooping(false);
  drum[5].volume(0.9);

  frameRate(24);
  for (int i = 0; i < 514 + 1 ; i++) { 
      wavetable[i]=((float)i/512)-0.5;
//      wavetable[i]=sin(radians((float)i/512*360))/2;      
  }
  for(int i=0;i<8;i++){
    waveform[i] = new Synth();
    waveform[i].waveTableSize(514);
    waveform[i].loadWaveTable(wavetable);
//    waveform[i].setFrequency(mtof[i*2+36]); 
  }
  for(int i=0;i<8;i++){
    waveform[i].play(); 
    waveform[i].ramp(0.,1);
    
  }
}
////////// end of Setup

void initWords(int source){
   int x=0; //temp x value
  String tempWord=""; //temp string holder
  wc=0;
  textSize(textsize);
  int vowels=0;
  int wordlen=0;
  char[] letters=message[source].toCharArray(); //create char copy of string in order to compare char type
  for (int i=0;i<message[source].length(); i++) {
     char ch=letters[i];
      if ((ch==65)||(ch==97)||(ch==69)||(ch==101)||(ch==73)||(ch==105)||(ch==79)||(ch==111)||(ch==85)||(ch==117)){
        vowels  ++;}
     if(ch!=32){
        tempWord=tempWord+message[source].charAt(i);
        wordlen++;
 //       println(tempWord);
     }
     else
     {    
        float ww=textWidth(tempWord+" ");        
        words[wc]=new Word(x,100,tempWord,ww,wordlen,vowels);
        x += ww;
        wc++;
        phraseS+=ww;
        tempWord="";
        wordlen=0;
        vowels=0;
     } 
  }
  
}

////////////  draw
void draw()
{
  background(bgnow);
  textAlign(LEFT);
  textSize(textsize);
  
  rectMode(CORNER);
  fill (0);
  noStroke();
  rect(shelfX,shelfY-25,width-shelfX,30); //shelf that word fall off of
  fill (0,128+hsnow,200+(hsnow/2),100);
  int hsn=hsnow/2;
  rect(hotSpot-hsn/2,0,20+hsn,height); //hot spot bar that triggers drum as letter pass
    
  for (int i = 0; i < wc; i++) {//cycle through each word
    words[i].display();//display it
    words[i].hotWord();//check if it is the hot word/letter
    if(words[i].isFall()){//check for falling
      words[i].fallDisplay();
      words[i].fall();//then fall
    }else{
      words[i].move();
    }
  }
  if (bgnow>bginit){ 
   bgnow=(int)(bgnow/16*15); //fade background to balck
  }
  if (hsnow>0){
   hsnow=(int)(hsnow/4*3); //fade hot spot bar
  }

}

void mousePressed(){ //mouse press changes the string driving the synth
  messnum++;
  initWords(messnum%message.length);
}

void attack(int v, int o, int n)  // trigger the synth voice
{
//  println("attack "+v+o+n);
  waveform[v].setFrequency(mtof[o*12+n+36]);
  waveform[v].ramp(0.2,1);
  waveform[v].setFilter(mtof[o*12+n+36]*8,10);
  waveform[v].filterRamp(mtof[o*12+n+36],2000);
}

void release(int v)  //set release for the synth voice
{
  waveform[v].ramp(0.,3000);
}

///////////////////////////////////////////////////
// A class to hold a single word and its properties
///////////////////////////////////////////////////
class Word {
  String word;
  // The object knows its original "home" location
  float homex,homey;
  // As well as its current location and width
  float x,y,a,wwidth;
  int l=99;
  int wlen;
  int numvow;
  int wordAge=0;
  int myV;
  float hyp, adj, opp, theta;
  float sx,sy;
  //int tsize=100;
  int tsize=20;
  int r,g,b;
  

  Word (float x_, float y_, String word_, float width_, int wlen_, int numvow_) {
    homex = x = x_;
    homey = y = y_;
    word = word_; 
    wwidth=width_;
    a=0;
    numvow=numvow_;
    wlen=wlen_;
  }


  // Display the word
  void display() {
    pushMatrix();
    fill(100);
    stroke(128);
    strokeWeight(2);
    textAlign(LEFT);
    translate(x+phraseP,y);
 //   rotate(radians(a));
    text(word,0,0);
    popMatrix();
  }
  
  void hotWord(){ //Hot word is the word currently over the hotspot. Similarly hot letter
   if(x+phraseP<hotSpot&&x+phraseP+wwidth>hotSpot){
    pushMatrix();
    fill(255,0,0);
    stroke(128);
    textAlign(LEFT);
    translate(x+phraseP,y);
 //   rotate(radians(a));
    text(word,0,0);
    popMatrix();
    float p=0;
    float s=0;
    char c;
    int beat=0;
    for(int i=0;i<word.length();i++){ //find if any letter is triggering the hot spot
      c=word.charAt(i);
      s=textWidth(c);
        int ls=phraseP+x+p;
        int le=ls+s;
          if((ls<hotSpot)&&(le>hotSpot)){
            if(l!=i){ //tests if we have already triggered this as hot letter
              l=i; //indicates this has already been flagged as hot letter
                  pushMatrix();
                  fill(0);
                  textAlign(LEFT);
                  textSize(80);
                  translate(ls-10,y-5);
                  text(c,0,0);
                  popMatrix();
                  textSize(textsize);
                  hsnow=100;
                  // use the letter type to pick a drum sound
                  char[] letter=c.toCharArray(); //create char copy of string in order to compare char type
                   char ch=letter[0];
                   int d;
                    if ((ch>=33)&&(ch<=47)){d=3;}//non-alphanumeric
                    if ((ch>=48)&&(ch<=57)){d=4;}//digits
                    if ((ch>=58)&&(ch<=64)){d=3;}//non-alphanumeric
                    if ((ch>=65)&&(ch<=90)){d=0;}//Upper case alpha
                    if ((ch>=91)&&(ch<=96)){d=3;}//non-alphanumeric
                    if ((ch>=97)&&(ch<=109)){d=2;}//lower case alpha - lower half
                    if ((ch>=110)&&(ch<=122)){d=5;}//lower case alpha - upper half
                    if ((ch>=123)&&(ch<=126)){d=3;}//non-alphanumeric
                    if (ch==32){;}//space
                    if ((ch==65)||(ch==97)||(ch==69)||(ch==101)||(ch==73)||(ch==105)||(ch==79)||(ch==111)||(ch==85)||(ch==117)){
                      d=1;}//vowels (upper or lower)
                    drum[d].stop(); 
                    drum[d].cue(0);
                    drum[d].play();

              break;
            }  
          }
        p+=s;
    }  
  }
}


boolean isFall(){ //Test if the word is ready to fall off the shelf
    int note,octave;
    if((phraseP+wwidth+x<shelfX)||(y<homey)){
      currP+=wwidth;
      y+=5;
      return true;
      }
      else if((phraseP+wwidth+x<shelfX+2)&&(y==homey)){ //highlight word just before it falls off the shelf
        pushMatrix();
        fill(0,255,0);
        stroke(128);
        textAlign(LEFT);
        textSize(40);
        translate(phraseP+x-10,y+5);
        text(word,0,0);
        popMatrix();
        textSize(textsize);        
        //change background colour temporarily
        bgnow=100;
        //setup sprial fall
        sx=phraseP+x; sy=y;
        float adj=vpx-sx;
        float opp=vpy-sy;
        theta=atan(opp/adj);
        hyp=opp/sin(theta);
        tsize=maxtsize;
        col=(int)random(50,220);// pick a colour for the falling word
        r=(int)random(col-80, col+80);
         if(r<0){r=0;}
         if(r>255){r=255;}
         g=(int)random(col-80, col+80);
         if(g<0){r=0;}
         if(g>255){r=255;}
         b=(int)random(col-80, col+80);
         if(b<0){r=0;}
         if(b>255){r=255;}

        //trigger fall sound

        octave=1;note=1;
        if(wlen<=3){octave=0;}// word size sets Octave
        else if (wlen<=6){octave=1;}
        else {octave=2;}        
        if(wlen-numvow<=1){note=1;}// number of non-vowels sets principle note
        if(wlen-numvow==2){note=3;}
        if(wlen-numvow==3){note=5;}
        if(wlen-numvow==4){note=6;}
        if(wlen-numvow==5){note=8;}
        if(wlen-numvow==6){note=10;}
        if(wlen-numvow>6){note=12;}
        if(numvow==0){note+=1;}// number of vowels shifts note up or down
        if(numvow==1){note+=2;}        
        if(numvow==2){note-=1;}        
        if(numvow>=3){note-=2;}
        if(note<1){note=1;}
        if(note>12){note=12;}        

        attack(currV,octave,note);
        wordAge=0;
        myV=currV;
        currV++;if (currV>7){currV=0;}
        return false;       
    }else
    {
      return false;
    }
}


// Display the falling word
 void fallDisplay() {
    pushMatrix();
    fill(r,g,b,180);
    textAlign(LEFT);
    translate(sx,sy);
    rotate(a);
    noStroke();
    // render falling text slows down the whole app so you can use the following rect instead
 //   rect(0,0,tsize,tsize);
    // These three lines display falling text but they render pretty slow and kill the app performance
    textSize(tsize);
    text(word,0,0);
    textSize(textsize);
    
    popMatrix();
}
  

void fall(){ //simulate falling
    y+=5;
    if(y>3*height){x=homex;y=homey;}
//  spiral falling
    theta+=spinSpeed;
    hyp-=fallSpeed;
   float fy=cos(theta)*hyp;
   float fx=sin(theta)*hyp;    
   if(hyp<5){hyp=5;}//x=homex;y=homey;}
     fill(100);
//    rect(vpx-fx,vpy-fy,10,10);
    sx=vpx-fx;sy=vpy-fy;
    a+=PI/150;
    tsize-=shrink;
    wordAge++;
    if (wordAge>=8){release(myV);}
}
  
  
  
void move() {
   x=x-2; 
  }

}

